﻿using System;

// 예제를 간단하게 하기 위해 최소한의 구현만을 포함시킴.
public class OldStack
{
    object[] _objList;
    int _pos;

    public OldStack(int size)
    {
        _objList = new object[size];
    }

    public void Push(object newValue)
    {
        _objList[_pos] = newValue;
        _pos++;
    }

    public object Pop()
    {
        _pos--;
        return _objList[_pos];
    }
}

// 예제를 간단하게 하기 위해 최소한의 구현만을 포함시킴.
public class NewStack<T>
{
    T[] _objList;
    int _pos;

    public NewStack(int size)
    {
        _objList = new T[size];
    }

    public void Push(T newValue)
    {
        _objList[_pos] = newValue;
        _pos++;
    }

    public T Pop()
    {
        _pos--;
        return _objList[_pos];
    }
}

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            OldStack stack = new OldStack(10);
            stack.Push(1);
            stack.Push(2);
            stack.Push(3);

            Console.WriteLine(stack.Pop());
            Console.WriteLine(stack.Pop());
            Console.WriteLine(stack.Pop());

            NewStack<int> intStack = new NewStack<int>(10);
            intStack.Push(1);
            intStack.Push(2);
            intStack.Push(3);

            Console.WriteLine(intStack.Pop());
            Console.WriteLine(intStack.Pop());
            Console.WriteLine(intStack.Pop());
        }
    }
}

